Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -567,464 +660,549 @@
  *
  * Returns:
  *************************************************************************/
-#ifdef QLA1280_PROFILE
-#define	PROC_BUF	(&qla1280_buffer[size])
-#define LUN_ID       (targ_lun>>(MAX_T_BITS+MAX_L_BITS)),((targ_lun>>MAX_L_BITS)&0xf), targ_lun&0x7 
-#endif
-int
-qla1280_proc_info ( char *buffer, char **start, off_t offset, int length, 
-                    int hostno, int inout)
-{
-#ifdef QLA1280_PROFILE
-  struct Scsi_Host *host;
-  scsi_qla_host_t *ha;
-  int    size = 0;
-  int  targ_lun;
-  scsi_lu_t  *up;
-  int   no_devices;
-
-  printk("Entering proc_info 0x%p,0x%lx,0x%x,0x%x\n",buffer,offset,length,hostno);
-  host = NULL;
-  /* find the host they want to look at */
-  for(ha=qla1280_hostlist; (ha != NULL) && ha->host->host_no != hostno; ha=ha->next)
-    ;
-
-  if (!ha)
-  {
-    size += sprintf(buffer, "Can't find adapter for host number %d\n", hostno);
-    if (size > length)
-    {
-      return (size);
-    }
-    else
-    {
-      return (length);
-    }
-  }
-
-  host = ha->host;
-  if (inout == TRUE) /* Has data been written to the file? */ 
-  {
-    return (qla1280_set_info(buffer, length, host));
-  }
-
-  /* compute number of active devices */
-  no_devices = 0;
-  for (targ_lun = 0; targ_lun < MAX_EQ; targ_lun++)
-  {
-          if( (up = ha->dev[targ_lun]) == NULL )
-              continue;
-          no_devices++;
-  }
-  /* size = 112 * no_devices; */
-  size = 4096;
-  /* round up to the next page */
-  
-  /* 
-   * if our old buffer is the right size use it otherwise 
-   * allocate a new one.
-   */
-  if (qla1280_buffer_size != size)
-  {
-    /* deallocate this buffer and get a new one */
-    if (qla1280_buffer != NULL) 
-    {
-      kfree(qla1280_buffer);
-      qla1280_buffer_size = 0;
-    }
-    qla1280_buffer = kmalloc(size, GFP_KERNEL);
-  }
-  if (qla1280_buffer == NULL)
-  {
-    size = sprintf(buffer, "qla1280 - kmalloc error at line %d\n",
-        __LINE__);
-    return size;
-  }
-  qla1280_buffer_size = size;
-
-  size = 0;
-  size += sprintf(PROC_BUF, "Qlogic 1280/1080 SCSI driver version: ");   /* 43 bytes */
-  size += sprintf(PROC_BUF, "%5s, ", QLA1280_VERSION);                         /* 5        */
-  size += sprintf(PROC_BUF, "Qlogic Firmware version: ");                     /* 25       */
-  size += sprintf(PROC_BUF, "%2d.%2d.%2d",_firmware_version[0],           /* 8        */
-                                          ql12_firmware_version[1],
-                                          ql12_firmware_version[2]);
-  size += sprintf(PROC_BUF, "\n");                                             /* 1       */
-                           
-  size += sprintf(PROC_BUF, "SCSI Host Adapter Information: %s\n", QLBoardTbl[ha->devnum].bdName);
-  size += sprintf(PROC_BUF, "Request Queue = 0x%lx, Response Queue = 0x%lx\n",
-                        ha->request_dma,
-                        ha->response_dma);
-  size += sprintf(PROC_BUF, "Request Queue count= 0x%x, Response Queue count= 0x%x\n",
-                        REQUEST_ENTRY_CNT,
-                        RESPONSE_ENTRY_CNT);
-  size += sprintf(PROC_BUF,"Number of pending commands = 0x%lx\n", ha->actthreads);
-  size += sprintf(PROC_BUF,"Number of queued commands = 0x%lx\n", ha->qthreads);
-  size += sprintf(PROC_BUF,"Number of free request entries = %d\n",ha->req_q_cnt);
-  size += sprintf(PROC_BUF, "\n");                                             /* 1       */
-                        
-  size += sprintf(PROC_BUF, "Attached devices:\n");
-  /* scan for all equipment stats */ 
-  for (targ_lun = 0; targ_lun < MAX_EQ; targ_lun++)
-  {
-      if( (up = ha->dev[targ_lun]) == NULL )
-           continue;
-      if( up->io_cnt == 0 )
-      {
-          size += sprintf(PROC_BUF,"(%2d:%2d:%2d) No stats\n",LUN_ID);
-           continue;
-      }
-      /* total reads since boot */
-      /* total writes since boot */
-      /* total requests since boot  */
-      size += sprintf(PROC_BUF, "Total requests %ld,",up->io_cnt);
-      /* current number of pending requests */
-      size += sprintf(PROC_BUF, "(%2d:%2d:%2d) pending requests %d,",LUN_ID,up->q_outcnt);
-      /* avg response time */
-      size += sprintf(PROC_BUF, "Avg response time %ld%%,",(up->resp_time/up->io_cnt)*100);
-      
-      /* avg active time */
-      size += sprintf(PROC_BUF, "Avg active time %ld%%\n",(up->act_time/up->io_cnt)*100);
-  }
-
-  if (size >= qla1280_buffer_size)
-  {
-    printk(KERN_WARNING "qla1280: Overflow buffer in qla1280_proc.c\n");
-  }
-
-  if (offset > size - 1)
-  {
-    kfree(qla1280_buffer);
-    qla1280_buffer = NULL;
-    qla1280_buffer_size = length = 0;
-    *start = NULL;
-  }
-  else
-  {
-    *start = &qla1280_buffer[offset];   /* Start of wanted data */
-    if (size - offset < length)
-    {
-      length = size - offset;
-    }
-  }
+#define	PROC_BUF	&qla1280_buffer[len]
+
+#if LINUX_VERSION_CODE < 0x020600
+static int qla1280_proc_info(char *buffer, char **start, off_t offset,
+			     int length, int hostno, int inout)
+#else
+static int qla1280_proc_info(struct Scsi_Host *host, char *buffer,
+			     char **start, off_t offset, int length, int inout)
+#endif
+{
+	struct scsi_qla_host *ha;
+	int size = 0;
+	int len = 0;
+	struct qla_boards *bdp;
+#ifdef BOGUS_QUEUE
+	struct scsi_lu *up;
+	uint32_t b, t, l;
+#endif
+#if LINUX_VERSION_CODE >= 0x020600
+	ha = (struct scsi_qla_host *)host->hostdata;
+#else
+	struct Scsi_Host *host;
+	/* Find the host that was specified */
+	for (ha = qla1280_hostlist; (ha != NULL)
+		     && ha->host->host_no != hostno; ha = ha->next) ;
+
+	/* if host wasn't found then exit */
+	if (!ha) {
+		size =  sprintf(buffer, "Can't find adapter for host "
+				"number %d\n", hostno);
+		if (size > length) {
+			return size;
+		} else {
+			return 0;
+		}
+	}
+
+	host = ha->host;
+#endif
+
+	if (inout)
+		return -ENOSYS;
+
+	/*
+	 * if our old buffer is the right size use it otherwise
+	 * allocate a new one.
+	 */
+	if (qla1280_buffer_size != PAGE_SIZE) {
+		/* deallocate this buffer and get a new one */
+		if (qla1280_buffer != NULL) {
+			free_page((unsigned long)qla1280_buffer);
+			qla1280_buffer_size = 0;
+		}
+		qla1280_buffer = (char *)get_zeroed_page(GFP_KERNEL);
+	}
+	if (qla1280_buffer == NULL) {
+		size = sprintf(buffer, "qla1280 - kmalloc error at line %d\n",
+			       __LINE__);
+		return size;
+	}
+	/* save the size of our buffer */
+	qla1280_buffer_size = PAGE_SIZE;
+
+	/* 3.20 clear the buffer we use for proc display */
+	memset(qla1280_buffer, 0, PAGE_SIZE);
+
+	/* start building the print buffer */
+	bdp = &ql1280_board_tbl[ha->devnum];
+	size = sprintf(PROC_BUF,
+		       "QLogic PCI to SCSI Adapter for ISP 1280/12160:\n"
+		       "        Firmware version: %2d.%02d.%02d, Driver version %s\n",
+		       bdp->fwver[0], bdp->fwver[1], bdp->fwver[2],
+		       QLA1280_VERSION);
+
+	len += size;
+
+	size = sprintf(PROC_BUF, "SCSI Host Adapter Information: %s\n",
+		       bdp->name);
+	len += size;
+	size = sprintf(PROC_BUF, "Request Queue count= 0x%x, Response "
+		       "Queue count= 0x%x\n",
+		       REQUEST_ENTRY_CNT, RESPONSE_ENTRY_CNT);
+	len += size;
+	size = sprintf(PROC_BUF, "Number of pending commands = 0x%lx\n",
+		       ha->actthreads);
+	len += size;
+	size = sprintf(PROC_BUF, "Number of free request entries = %d\n",
+		       ha->req_q_cnt);
+	len += size;
+	size = sprintf(PROC_BUF, "\n");	/* 1       */
+	len += size;
+
+	size = sprintf(PROC_BUF, "SCSI device Information:\n");
+	len += size;
+#ifdef BOGUS_QUEUE
+	/* scan for all equipment stats */
+	for (b = 0; b < MAX_BUSES; b++)
+		for (t = 0; t < MAX_TARGETS; t++) {
+			for (l = 0; l < MAX_LUNS; l++) {
+				up = LU_Q(ha, b, t, l);
+				if (up == NULL)
+					continue;
+				/* unused device/lun */
+				if (up->io_cnt == 0 || up->io_cnt < 2)
+					continue;
+				/* total reads since boot */
+				/* total writes since boot */
+				/* total requests since boot  */
+				size = sprintf (PROC_BUF,
+						"(%2d:%2d:%2d): Total reqs %ld,",
+						b, t, l, up->io_cnt);
+				len += size;
+				/* current number of pending requests */
+				size =	sprintf(PROC_BUF, " Pend reqs %d,",
+						up->q_outcnt);
+				len += size;
+#if 0
+				/* avg response time */
+				size = sprintf(PROC_BUF, " Avg resp time %ld%%,",
+					       (up->resp_time / up->io_cnt) *
+					       100);
+				len += size;
+
+				/* avg active time */
+				size = sprintf(PROC_BUF,
+					       " Avg active time %ld%%\n",
+					       (up->act_time / up->io_cnt) * 100);
+#else
+				size = sprintf(PROC_BUF, "\n");
 #endif
+				len += size;
+			}
+			if (len >= qla1280_buffer_size)
+				break;
+		}
+#endif
+
+	if (len >= qla1280_buffer_size) {
+		printk(KERN_WARNING
+		       "qla1280: Overflow buffer in qla1280_proc.c\n");
+	}
+
+	if (offset > len - 1) {
+		free_page((unsigned long) qla1280_buffer);
+		qla1280_buffer = NULL;
+		qla1280_buffer_size = length = 0;
+		*start = NULL;
+	} else {
+		*start = &qla1280_buffer[offset];	/* Start of wanted data */
+		if (len - offset < length) {
+			length = len - offset;
+		}
+	}
+	return length;
+}
+
+
+static int qla1280_read_nvram(struct scsi_qla_host *ha)
+{
+	uint16_t *wptr;
+	uint8_t chksum;
+	int cnt;
+	struct nvram *nv;
+
+	ENTER("qla1280_read_nvram");
+
+	if (driver_setup.no_nvram)
+		return 1;
+
+	printk(KERN_INFO "scsi(%ld): Reading NVRAM\n", ha->host_no);
+
+	wptr = (uint16_t *)&ha->nvram;
+	nv = &ha->nvram;
+	chksum = 0;
+	for (cnt = 0; cnt < 3; cnt++) {
+		*wptr = qla1280_get_nvram_word(ha, cnt);
+		chksum += *wptr & 0xff;
+		chksum += (*wptr >> 8) & 0xff;
+		wptr++;
+	}
 
-  return (length);
+	if (nv->id0 != 'I' || nv->id1 != 'S' ||
+	    nv->id2 != 'P' || nv->id3 != ' ' || nv->version < 1) {
+		dprintk(2, "Invalid nvram ID or version!\n");
+		chksum = 1;
+	} else {
+		for (; cnt < sizeof(struct nvram); cnt++) {
+			*wptr = qla1280_get_nvram_word(ha, cnt);
+			chksum += *wptr & 0xff;
+			chksum += (*wptr >> 8) & 0xff;
+			wptr++;
+		}
+	}
+
+	dprintk(3, "qla1280_read_nvram: NVRAM Magic ID= %c %c %c %02x"
+	       " version %i\n", nv->id0, nv->id1, nv->id2, nv->id3,
+	       nv->version);
+
+
+	if (chksum) {
+		if (!driver_setup.no_nvram)
+			printk(KERN_WARNING "scsi(%ld): Unable to identify or "
+			       "validate NVRAM checksum, using default "
+			       "settings\n", ha->host_no);
+		ha->nvram_valid = 0;
+	} else
+		ha->nvram_valid = 1;
+
+	dprintk(1, "qla1280_read_nvram: Completed Reading NVRAM\n");
+	LEAVE("qla1280_read_nvram");
+
+	return chksum;
 }
 
 
 /**************************************************************************
- * qla1280_detect
- *    This routine will probe for Qlogic 1280 SCSI host adapters.
- *    It returns the number of host adapters of a particular
- *    type that were found.	 It also initialize all data necessary for 
- *    the driver.  It is passed-in the host number, so that it
- *    knows where its first entry is in the scsi_hosts[] array.
+ * qla1280_do_device_init
+ *    This routine will register the device with the SCSI subsystem,
+ *    initialize the host adapter structure and call the device init
+ *    routines.
  *
  * Input:
- *     template - pointer to SCSI template
+ *     pdev      - pointer to struct pci_dev for adapter
+ *     template  - pointer to SCSI template
+ *     devnum    - the device number
+ *     bdp       - pointer to struct _qlaboards
+ *     num_hosts - the host number
  *
  * Returns:
- *  num - number of host adapters found.  
+ *  host - pointer to SCSI host structure
  **************************************************************************/
-int
-qla1280_detect(Scsi_Host_Template *template)
-{
-    int num_hosts = 0;
-    struct Scsi_Host *host;
-    scsi_qla_host_t *ha, *cur_ha;
-    struct _qlaboards  *bdp;
-    int i, j;
-#if LINUX_VERSION_CODE <= KERNEL_VERSION(2,1,95)
-    unsigned int piobase;
-    unsigned char pci_bus, pci_devfn, pci_irq;
-    config_reg_t   *cfgp = 0;
-#endif
-    device_reg_t   *reg;
-    char   *cp;
-#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,95)
-    struct pci_dev *pdev = NULL;
+struct Scsi_Host *
+qla1280_do_device_init(struct pci_dev *pdev, Scsi_Host_Template * template,
+		       int devnum, struct qla_boards *bdp, int num_hosts)
+{
+	struct Scsi_Host *host;
+	struct scsi_qla_host *ha;
+
+	printk(KERN_INFO "qla1280: %s found on PCI bus %i, dev %i\n",
+	       bdp->name, pdev->bus->number, PCI_SLOT(pdev->devfn));
+
+	host = scsi_register(template, sizeof(struct scsi_qla_host));
+	if (!host) {
+		printk(KERN_WARNING
+		       "qla1280: Failed to register host, aborting.\n");
+		goto error;
+	}
+
+#if LINUX_VERSION_CODE < 0x020545
+	scsi_set_pci_device(host, pdev);
 #else
-    int index;
+	scsi_set_device(host, &pdev->dev);
 #endif
+	ha = (struct scsi_qla_host *)host->hostdata;
+	/* Clear our data area */
+	memset(ha, 0, sizeof(struct scsi_qla_host));
+	/* Sanitize the information from PCI BIOS.  */
+	host->irq = pdev->irq;
+	ha->pci_bus = pdev->bus->number;
+	ha->pci_device_fn = pdev->devfn;
+	ha->pdev = pdev;
+	ha->device_id = bdp->device_id;
+	ha->devnum = devnum;	/* specifies microcode load address */
+
+	if (qla1280_mem_alloc(ha)) {
+		printk(KERN_INFO "qla1x160: Failed to get memory\n");
+		goto error_scsi_unregister;
+	}
 
-    ENTER("qla1280_detect");
+	ha->ports = bdp->numPorts;
+	/* following needed for all cases of OS versions */
+	ha->host = host;
+	ha->host_no = host->host_no;
 
-#ifdef CHECKSRBSIZE
-    if (sizeof(srb_t) > sizeof(Scsi_Pointer) )
-    {
-      printk("Redefine SRB - its too big");
-      return 0;
-    }
+	host->can_queue = 0xfffff;	/* unlimited  */
+	host->cmd_per_lun = 1;
+	host->base = (unsigned long)ha->mmpbase;
+	host->max_channel = bdp->numPorts - 1;
+	host->max_lun = MAX_LUNS - 1;
+	host->max_id = MAX_TARGETS;
+	host->max_sectors = 1024;
+#if LINUX_VERSION_CODE < 0x020545
+	host->select_queue_depths = qla1280_select_queue_depth;
 #endif
 
-#ifdef MODULE
-	DEBUG(sprintf(debug_buff,"DEBUG: qla1280_detect starts at address = %p\n",qla1280_detect);)
-	DEBUG(qla1280_print(debug_buff);)
-    /*
-    * If we are called as a module, the qla1280 pointer may not be null
-    * and it would point to our bootup string, just like on the lilo
-    * command line.  IF not NULL, then process this config string with
-    * qla1280_setup
-    *
-    * Boot time Options
-    * To add options at boot time add a line to your lilo.conf file like:
-    * append="qla1280=verbose,max_tags:{{255,255,255,255},{255,255,255,255}}"
-    * which will result in the first four devices on the first two
-    * controllers being set to a tagged queue depth of 32.
-    */
-    if(options)
-        qla1280_setup(options, NULL);
-    if(dummy_buffer[0] != 'P')
-        printk(KERN_WARNING "qla1280: Please read the file /usr/src/linux/drivers"
-                "/scsi/README.qla1280\n"
-                "qla1280: to see the proper way to specify options to the qla1280 "
-                "module\n"
-                "qla1280: Specifically, don't use any commas when passing arguments to\n"
-                "qla1280: insmod or else it might trash certain memory areas.\n");
-#endif
-
-    if ((int) !pcibios_present())
-    {
-		printk("scsi: PCI not present\n");
-		return 0;
-    } /* end of IF */
-    bdp = &QLBoardTbl[0];
-    qla1280_hostlist = NULL;
-#if 0
-    template->proc_dir = &proc_scsi_qla1280;
-#else
-    template->proc_name = "qla1280";
+	ha->instance = num_hosts;
+	host->unique_id = ha->instance;
+
+	if (qla1280_pci_config(ha)) {
+		printk(KERN_INFO "qla1x160: Unable to configure PCI\n");
+		goto error_mem_alloced;
+	}
+
+	/* Disable ISP interrupts. */
+	qla1280_disable_intrs(ha);
+
+	/* Register the IRQ with Linux (sharable) */
+	if (request_irq(host->irq, qla1280_intr_handler, SA_SHIRQ,
+			"qla1280", ha)) {
+		printk("qla1280 : Failed to reserve interrupt %d already "
+		       "in use\n", host->irq);
+		goto error_iounmap;
+	}
+#if !MEMORY_MAPPED_IO
+	/* Register the I/O space with Linux */
+	if (!request_region(host->io_port, 0xff, "qla1280")) {
+		printk("qla1280: Failed to reserve i/o region 0x%04lx-0x%04lx"
+		       " already in use\n",
+		       host->io_port, host->io_port + 0xff);
+		goto error_free_irq;
+	}
 #endif
-    
-	/* Try and find each different type of adapter we support */
-	for( i=0; bdp->device_id != 0 && i < NUM_OF_ISP_DEVICES; i++, bdp++ ) {
-#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,95)
-		while ((pdev = pci_find_device(QLA1280_VENDOR_ID,
-			bdp->device_id, pdev ) ))  {
-		if (pci_enable_device(pdev)) continue;
-#else
-		while (!(pcibios_find_device(QLA1280_VENDOR_ID,
-			bdp->device_id,
-			index++, &pci_bus, &pci_devfn)) )  {
-#endif
-                /* found a adapter */
-		host = scsi_register(template, sizeof(scsi_qla_host_t));
-                if (!host) { 
-			printk(KERN_WARNING "qla1280: Failed to register host, aborting.\n");
-                        return 0;
-                }
-		scsi_set_pci_device(host, pdev);
-		ha = (scsi_qla_host_t *) host->hostdata;
-		/* Clear our data area */
-		for( j =0, cp = (char *)ha;  j < sizeof(scsi_qla_host_t); j++)
-			*cp = 0;
-		/* Sanitize the information from PCI BIOS.  */
-#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,95)
-		host->irq = pdev->irq;
-		host->io_port = pci_resource_start(pdev, 0);
-		ha->pci_bus = pdev->bus->number;
-		ha->pci_device_fn = pdev->devfn;
-		ha->pdev = pdev;
-#else
-		pcibios_read_config_byte(pci_bus, pci_devfn, OFFSET(cfgp->interrupt_line), &pci_irq);
-		pcibios_read_config_dword(pci_bus, pci_devfn, OFFSET(cfgp->base_port), &piobase);
-		host->irq = pci_irq;
-		host->io_port = (unsigned int) piobase;
-		host->io_port &= PCI_BASE_ADDRESS_IO_MASK;
-		ha->pci_bus = pci_bus;
-		ha->pci_device_fn = pci_devfn;
-#endif
-		ha->device_id = bdp->device_id;
-    
-                ha->devnum = i;
-		if( qla1280_mem_alloc(ha) ) {
-			printk(KERN_INFO "qla1280: Failed to allocate memory for adapter\n");
-		}
-                
-                ha->ports = bdp->numPorts; 
-                ha->iobase = (device_reg_t *) host->io_port;
-                ha->host = host;
-                ha->host_no = host->host_no;
-
-                /* load the F/W, read paramaters, and init the H/W */
-                if (qla1280_initialize_adapter(ha))
-                {
-
-                    printk(KERN_INFO "qla1280: Failed to initialized adapter\n");
-                    qla1280_mem_free(ha);
-                    scsi_unregister(host);
-                    continue;
-                }
-                
-                host->max_channel = bdp->numPorts-1; 
-                ha->instance = num_hosts;
-		/* Register our resources with Linux */
-		if( qla1280_register_with_Linux(ha, bdp->numPorts-1) ) {
-			printk(KERN_INFO "qla1280: Failed to register our resources\n");
-			qla1280_mem_free(ha);
-			scsi_unregister(host);
-			continue;
-		}
 
+	/* load the F/W, read paramaters, and init the H/W */
+	if (qla1280_initialize_adapter(ha)) {
+		printk(KERN_INFO "qla1x160: Failed to initialize adapter\n");
+		goto error_release_region;
+	}
 
-                reg = ha->iobase;
-                /* Disable ISP interrupts. */
-		qla1280_disable_intrs(ha);
+	/* set our host ID  (need to do something about our two IDs) */
+	host->this_id = ha->bus_settings[0].id;
 
-                /* Insure mailbox registers are free. */
-                WRT_REG_WORD(&reg->semaphore, 0);
-                WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
-                WRT_REG_WORD(&reg->host_cmd, HC_CLR_HOST_INT);
-
-                /* Enable chip interrupts. */
-		qla1280_enable_intrs(ha);
-               
-                /* Insert new entry into the list of adapters */
-                ha->next = NULL;
-                if( qla1280_hostlist == NULL )
-                {
-                    cur_ha = qla1280_hostlist = ha;
-                }
-                else
-                {
-                    cur_ha = qla1280_hostlist;
-                    while( cur_ha->next != NULL )
-                        cur_ha = cur_ha->next;
-                    cur_ha->next = ha;
-                }
-                num_hosts++;
-            }  /* end of WHILE */
-        } /* end of FOR */
+	return host;
 
-    LEAVE("qla1280_detect");
-    return num_hosts; 
+ error_release_region:
+#if !MEMORY_MAPPED_IO
+	release_region(host->io_port, 0xff);
+ error_free_irq:
+#endif
+	free_irq(host->irq, ha);
+ error_iounmap:
+#if MEMORY_MAPPED_IO
+	if (ha->mmpbase)
+		iounmap((void *)(((unsigned long) ha->mmpbase) & PAGE_MASK));
+#endif
+ error_mem_alloced:
+	qla1280_mem_free(ha);
+ error_scsi_unregister:
+	scsi_unregister(host);
+ error:
+	return NULL;
 }
 
 /**************************************************************************
-*   qla1280_register_with_Linux
-*
-* Description:
-*   Free the passed in Scsi_Host memory structures prior to unloading the
-*   module.
-*
-* Input:
-*     ha - pointer to host adapter structure
-*     maxchannels - MAX number of channels.
-*
-* Returns:
-*  0 - Sucessfully reserved resources.
-*  1 - Failed to reserved a resource.
-**************************************************************************/
-STATIC uint8_t  qla1280_register_with_Linux(scsi_qla_host_t *ha, uint8_t maxchannels)
+ * qla1280_detect
+ *    This routine will probe for Qlogic 1280 SCSI host adapters.
+ *    It returns the number of host adapters of a particular
+ *    type that were found.	 It also initialize all data necessary for
+ *    the driver.  It is passed-in the host number, so that it
+ *    knows where its first entry is in the scsi_hosts[] array.
+ *
+ * Input:
+ *     template - pointer to SCSI template
+ *
+ * Returns:
+ *  num - number of host adapters found.
+ **************************************************************************/
+static int
+qla1280_detect(Scsi_Host_Template * template)
 {
+	struct pci_dev *pdev = NULL;
+	struct Scsi_Host *host;
+	struct scsi_qla_host *ha, *cur_ha;
+	struct qla_boards *bdp;
+	uint16_t subsys_vendor, subsys_device;
+	int num_hosts = 0;
+	int devnum = 0;
+
+	ENTER("qla1280_detect");
+
+	if (sizeof(struct srb) > sizeof(Scsi_Pointer)) {
+		printk(KERN_WARNING
+		       "qla1280_detect: [WARNING] struct srb too big\n");
+		return 0;
+	}
+#ifdef MODULE
+	/*
+	 * If we are called as a module, the qla1280 pointer may not be null
+	 * and it would point to our bootup string, just like on the lilo
+	 * command line.  IF not NULL, then process this config string with
+	 * qla1280_setup
+	 *
+	 * Boot time Options
+	 * To add options at boot time add a line to your lilo.conf file like:
+	 * append="qla1280=verbose,max_tags:{{255,255,255,255},{255,255,255,255}}"
+	 * which will result in the first four devices on the first two
+	 * controllers being set to a tagged queue depth of 32.
+	 */
+	if (qla1280)
+		qla1280_setup(qla1280);
+#endif
+
+	bdp = &ql1280_board_tbl[0];
+	qla1280_hostlist = NULL;
+	template->proc_name = "qla1280";
+
+	/* First Initialize QLA12160 on PCI Bus 1 Dev 2 */
+	while ((pdev = pci_find_subsys(PCI_VENDOR_ID_QLOGIC, bdp->device_id,
+				       PCI_ANY_ID, PCI_ANY_ID, pdev))) {
 
-	struct Scsi_Host *host = ha->host;
+		/* find QLA12160 device on PCI bus=1 slot=2 */
+		if ((pdev->bus->number != 1) || (PCI_SLOT(pdev->devfn) != 2))
+			continue;
 
-	host->can_queue = 0xfffff;  /* unlimited  */
-	host->cmd_per_lun = 1;
-       host->select_queue_depths = qla1280_select_queue_depth;
-	host->n_io_port = 0xFF;
-	host->base = (unsigned long) ha->mmpbase;
-	host->max_channel = maxchannels; 
-       host->max_lun = MAX_LUNS-1; 
-	host->unique_id = ha->instance;
-       host->max_id = MAX_TARGETS; 
-       host->unique_id = ha->instance;
+		/* Bypass all AMI SUBSYS VENDOR IDs */
+		if (pdev->subsystem_vendor == PCI_VENDOR_ID_AMI) {
+			printk(KERN_INFO
+			       "qla1x160: Skip AMI SubSys Vendor ID Chip\n");
+			continue;
+		}
 
-	/* set our host ID  (need to do something about our two IDs) */
-       host->this_id = ha->bus_settings[0].id;
-       /* Register the IRQ with Linux (sharable) */
-       if ( request_irq(host->irq, qla1280_intr_handler, SA_INTERRUPT| SA_SHIRQ, "qla1280", ha))
-       {
-          printk("qla1280 : Failed to reserved interrupt %d already in use\n", host->irq);
-          qla1280_mem_free(ha);
-          scsi_unregister(host);
-	     return 1;
-       }
-
-       /* Register the I/O space with Linux */
-       if (check_region(host->io_port, 0xff))
-       {
-           printk("qla1280 : Failed to reserved i/o region 0x%04lx-0x%04lx already in use\n",
-              host->io_port, host->io_port + 0xff);
-           free_irq(host->irq, NULL);
-           qla1280_mem_free(ha);
-           scsi_unregister(host);
-	     return 1;
-       }
+		if (pci_enable_device(pdev))
+			goto find_devices;
+
+		host = qla1280_do_device_init(pdev, template, devnum,
+					      bdp, num_hosts);
+		if (!host)
+			continue;
+		ha = (struct scsi_qla_host *)host->hostdata;
 
-       request_region(host->io_port, 0xff, "qla1280");
+		/* this preferred device will always be the first one found */
+		cur_ha = qla1280_hostlist = ha;
+		num_hosts++;
+	}
 
-	return 0;
-}
+ find_devices:
 
+	pdev = NULL;
+	/* Try and find each different type of adapter we support */
+	for (devnum = 0; bdp->device_id != 0 && devnum < NUM_OF_ISP_DEVICES;
+	     devnum++, bdp++) {
+		/* PCI_SUBSYSTEM_IDS supported */
+		while ((pdev = pci_find_subsys(PCI_VENDOR_ID_QLOGIC,
+					       bdp->device_id, PCI_ANY_ID,
+					       PCI_ANY_ID, pdev))) {
+			if (pci_enable_device(pdev))
+				continue;
+			/* found an adapter */
+			subsys_vendor = pdev->subsystem_vendor;
+			subsys_device = pdev->subsystem_device;
+
+			/*
+			 * skip QLA12160 already initialized on
+			 * PCI Bus 1 Dev 2 since we already initialized
+			 * and presented it
+			 */
+			if ((bdp->device_id == PCI_DEVICE_ID_QLOGIC_ISP12160)&&
+			    (pdev->bus->number == 1) &&
+			    (PCI_SLOT(pdev->devfn) == 2))
+				continue;
+
+			/* Bypass all AMI SUBSYS VENDOR IDs */
+			if (subsys_vendor == PCI_VENDOR_ID_AMI) {
+				printk(KERN_INFO
+				       "qla1x160: Skip AMI SubSys Vendor ID Chip\n");
+				continue;
+			}
+			dprintk(1, "qla1x160: Supported Device Found VID=%x "
+			       "DID=%x SSVID=%x SSDID=%x\n", pdev->vendor,
+			       pdev->device, subsys_vendor, subsys_device);
+
+			host = qla1280_do_device_init(pdev, template,
+						      devnum, bdp, num_hosts);
+			if (!host)
+				continue;
+			ha = (struct scsi_qla_host *)host->hostdata;
+
+			if (qla1280_hostlist == NULL) {
+				cur_ha = qla1280_hostlist = ha;
+			} else {
+				cur_ha = qla1280_hostlist;
+				while (cur_ha->next != NULL)
+					cur_ha = cur_ha->next;
+				cur_ha->next = ha;
+			}
+			num_hosts++;
+		}		/* end of WHILE */
+	}			/* end of FOR */
+
+	LEAVE("qla1280_detect");
+	return num_hosts;
+}
 
 /**************************************************************************
  *   qla1280_release
  *   Free the passed in Scsi_Host memory structures prior to unloading the
  *   module.
  **************************************************************************/
-int
+static int
 qla1280_release(struct Scsi_Host *host)
 {
-    scsi_qla_host_t *ha = (scsi_qla_host_t *) host->hostdata;
-
-    ENTER("qla1280_release");
+	struct scsi_qla_host *ha = (struct scsi_qla_host *)host->hostdata;
 
-    if( !ha->flags.online )
-        return(0);
+	ENTER("qla1280_release");
 
-    /* turn-off interrupts on the card */
-    WRT_REG_WORD(&ha->iobase->ictrl, 0);
+	if (!ha->flags.online)
+		return 0;
 
-    /* Detach interrupts */
-    if(host->irq)
-        free_irq(host->irq, ha);
+	/* turn-off interrupts on the card */
+	WRT_REG_WORD(&ha->iobase->ictrl, 0);
 
-    /* release io space registers  */
-    if( host->io_port )
-        release_region(host->io_port, 0xff);
+	/* Detach interrupts */
+	if (host->irq)
+		free_irq(host->irq, ha);
 
 #if MEMORY_MAPPED_IO
-    if(ha->mmpbase)
-    {
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,0)
-        vfree((void *) (((unsigned long) ha->mmpbase) & PAGE_MASK));
+	if (ha->mmpbase)
+		iounmap(ha->mmpbase);
 #else
-        iounmap((void *) (((unsigned long) ha->mmpbase) & PAGE_MASK));
-#endif
-    }
-#endif /* MEMORY_MAPPED_IO */
-    qla1280_mem_free(ha);
+	/* release io space registers  */
+	if (host->io_port)
+		release_region(host->io_port, 0xff);
+#endif				/* MEMORY_MAPPED_IO */
 
-    ENTER("qla1280_release");
-    return(0);
+	qla1280_mem_free(ha);
+
+	ENTER("qla1280_release");
+	return 0;
 }
 
 /**************************************************************************
  *   qla1280_info
  *     Return a string describing the driver.
  **************************************************************************/
-const char *
+static const char *
 qla1280_info(struct Scsi_Host *host)
 {
-    static char qla1280_buffer[125];
-    char *bp;
-    scsi_qla_host_t *ha;
-    qla_boards_t   *bdp; 
-
-    bp = &qla1280_buffer[0];
-    ha = (scsi_qla_host_t *)host->hostdata;
-    bdp = &QLBoardTbl[ha->devnum];
-    memset(bp, 0, sizeof(qla1280_buffer));
-    sprintf(bp,
-            "QLogic %sPCI to SCSI Host Adapter: bus %d device %d irq %d\n"
-            "       Firmware version: %2d.%02d.%02d, Driver version %s",
-            (char *)&bdp->bdName[0], ha->pci_bus, (ha->pci_device_fn & 0xf8) >> 3, host->irq,
-            bdp->fwver[0],bdp->fwver[1],bdp->fwver[2],
-            QLA1280_VERSION);
-    return(bp);
+	static char qla1280_scsi_name_buffer[125];
+	char *bp;
+	struct scsi_qla_host *ha;
+	struct qla_boards *bdp;
+
+	bp = &qla1280_scsi_name_buffer[0];
+	ha = (struct scsi_qla_host *)host->hostdata;
+	bdp = &ql1280_board_tbl[ha->devnum];
+	memset(bp, 0, sizeof(qla1280_scsi_name_buffer));
+	sprintf (bp,
+		 "QLogic %s PCI to SCSI Host Adapter: bus %d device %d irq %d\n"
+		 "       Firmware version: %2d.%02d.%02d, Driver version %s",
+		 &bdp->name[0], ha->pci_bus, (ha->pci_device_fn & 0xf8) >> 3,
+		 host->irq, bdp->fwver[0], bdp->fwver[1], bdp->fwver[2],
+		 QLA1280_VERSION);
+	return bp;
 }
 
 /**************************************************************************
